import resourceTable from './resource.schema'
import resourceStatsTable from './resource-stats.schema'
import collectionStatsTable from './collection-stats.schema'
import collectionTable from './collection.schema'
import subjectsTable from './subject.schema'
import submissionTable from './submission.schema'
import licenseTable from './license.schema'
import languageTable from './language.schema'
import educationalStageTable from './educational-stage.schema'
import passwordRecoveryTable, { 
  passwordRecoveryTableRelations 
} from './password-recovery.schema'
import userStatsTable from './user-stats.schema'
import userTable from './user.schema'
import objectTypeTable from './object-type.schema'
import complaintTable from './complaint.schema'
import resourceSubjectsTable from '../relations/resource-subject.relation'
import achievementTable from './achievement.schema'
import resourceLanguagesTable from '../relations/resource-language.relation'
import followRelationTable from '../relations/followers.relation'
import roleTable from './role.schema'
import collectionLikesTable from '../relations/collection-like.relation'
import userRoleRelationTable from '../relations/user-role.relation'
import collectionResourcesTable from '../relations/collection-resource.relation'
import institutionTable from './institution.schema'
import userInstitutionRelationTable from '../relations/user-institution.relation'
import resourceLikesTable from '../relations/resource-like.relation'
import resourceEducationalStagesTable from '../relations/resource-educational-stage.relation'
import itemsTable from './item.schema'
import userAchievementsTable from '../relations/user-achievement.relation'
import actionTable from './action.schema'
import notificationRelationTable from '../relations/notification.relation'
import userItemRelationTable from '../relations/user-item.relation'
import stateEnum from './stateEnum.schema'

export {
  userTable,
  userStatsTable,
  resourceTable,
  collectionTable,
  resourceStatsTable,
  collectionStatsTable,
  subjectsTable,
  submissionTable,
  licenseTable,
  languageTable,
  educationalStageTable,
  passwordRecoveryTable,
  passwordRecoveryTableRelations,
  objectTypeTable,
  roleTable,
  complaintTable,
  followRelationTable,
  collectionLikesTable,
  resourceLanguagesTable,
  userRoleRelationTable,
  collectionResourcesTable,
  resourceSubjectsTable,
  institutionTable,
  userInstitutionRelationTable,
  resourceLikesTable,
  resourceEducationalStagesTable,
  achievementTable,
  itemsTable,
  userAchievementsTable,
  actionTable,
  notificationRelationTable,
  userItemRelationTable,
  stateEnum,
}

export const tables = [
  userTable, 
  passwordRecoveryTable,
  userStatsTable,
  resourceTable,
  resourceStatsTable,
  collectionTable,
  collectionStatsTable,
  subjectsTable,
  submissionTable,
  licenseTable,
  languageTable,
  educationalStageTable,
  objectTypeTable,
  roleTable,
  followRelationTable,
  complaintTable,
  collectionLikesTable,
  userRoleRelationTable,
  collectionResourcesTable,
  institutionTable,
  userInstitutionRelationTable,
  resourceLikesTable,
  achievementTable,
  itemsTable,
  userAchievementsTable,
  actionTable,
  notificationRelationTable,
  userItemRelationTable,
]
