import { AchievementRepo } from "@/db/repo/achievement.repo";
import type { AchievementInput, AchievementModel, AchievementUpdate } from "@/db/schema/achievement.schema";
import { Inject, Service } from "typedi";

@Service()
export class AchievementService {
  @Inject()
  private readonly repo: AchievementRepo;

  async create(achievement: AchievementInput): Promise<AchievementModel> {
    return this.repo.create(achievement)
  }

  async update(achievement: AchievementUpdate): Promise<AchievementModel> {
    return this.repo.update(achievement)
  }

  async delete(id: AchievementModel['id']): Promise<AchievementModel> {
    return this.repo.delete(id)
  }

  async find(id: AchievementModel['id']): Promise<AchievementModel | undefined> {
    return this.repo.find(id)
  }

  async findMany(): Promise<AchievementModel[]> {
    return this.repo.findMany()
  }
}