import type db from "@/db"
import { ActionRepo } from "@/db/repo/action.repo"
import type { ActionModel, ActionInput, ActionUpdate } from "@/db/schema/action.schema"
import { Inject, Service } from "typedi"

@Service()
export class ActionService{
  @Inject()
  private readonly repo: ActionRepo

  async findMany():Promise<ActionModel[]>{
    
    return this.repo.findMany()
  }
  async findById(id: ActionModel['id']): Promise<ActionModel | null>{

    return this.repo.findById(id)
  }
  async findByName(name: ActionModel['name']): Promise<ActionModel | null>{
    
    return this.repo.findByName(name)
  }
  async create(action: ActionInput, tx?: db): Promise<ActionModel>{

    return this.repo.create(action, tx)
  }
  async update(action: ActionUpdate): Promise<ActionModel>{

    return this.repo.update(action)
  }
  async delete(id: ActionModel['id']): Promise<ActionModel>{

    return this.repo.delete(id)
  }
}