import { collectionResourcesRepo } from "@/db/repo/collection-resources.repo";
import type { CollectionModel } from "@/db/schema/collection.schema";
import type { ResourceModel } from "@/db/schema/resource.schema";
import { Inject, Service } from "typedi";

@Service()
export class CollectionResourcesService {
  @Inject()
  private readonly repo: collectionResourcesRepo;

  async associateCollectionWithResources(collectionId: CollectionModel['id'], resourceIds: ResourceModel['id'][]): Promise<void> {
    await this.repo.associateCollectionsWithResources(collectionId, resourceIds);
  }

  async getResourcesbyCollection(collectionId: CollectionModel['id']): Promise<ResourceModel[]> {
    return this.repo.getResourcesbyCollection(collectionId);
  }

  async removeResourcesFromCollection(collectionId: CollectionModel['id'], resourceIds: ResourceModel['id'][]): Promise<void> {
    await this.repo.removeResourcesFromCollection(collectionId, resourceIds);
  }

  async isAssociationExists(collectionId: CollectionModel['id'], resourceId: ResourceModel['id']): Promise<boolean> {
    return this.repo.isAssociationExists(collectionId, resourceId);
  }

  async getCollectionsbyResource(resourceId: ResourceModel['id']): Promise<CollectionModel[]> {
    return this.repo.getCollectionsbyResource(resourceId);
  }
}