import { CollectionRepo } from '@/db/repo/collections.repo'
import { Inject, Service } from 'typedi'
import type { 
  CollectionInput, 
  CollectionModel,
  CollectionUpdate
} from '@/db/schema/collection.schema'

@Service()
export class CollectionsService {
  @Inject()
  private readonly repo: CollectionRepo

  async create(collection: CollectionInput): Promise<CollectionModel> {
    return this.repo.create(collection)
  }

  async update(collection: CollectionUpdate): Promise<CollectionModel> {
    return this.repo.update(collection)
  }

  async delete(id: CollectionModel['id']): Promise<CollectionModel> {
    return this.repo.delete(id)
  }

  async deletePermanently(id: CollectionModel['id']): Promise<CollectionModel> {
    return this.repo.deletePermanently(id)
  }

  async restore(id: CollectionModel['id']): Promise<CollectionModel> {
    return this.repo.restore(id)
  }

  async find(
    id: CollectionModel['id'] 
  ): Promise<CollectionModel | undefined> {
    return this.repo.find(id)
  }

  async findMany(): Promise<CollectionModel[]> {
    return this.repo.findMany()
  }
}