import  { educationalStageRepo } from "@/db/repo/educational-stage.repo";
import type { EducationalStagesInput, EducationalStagesModel, EducationalStagesUpdate } from "@/db/schema/educational-stage.schema";
import { Inject, Service } from "typedi";


@Service()
export class EducationalStageService {
    @Inject()
    private readonly repo: educationalStageRepo

    async create(educationalStage: EducationalStagesInput): Promise<EducationalStagesModel> {
        return this.repo.create(educationalStage)
    }

    async update(educationalStage: EducationalStagesUpdate): Promise<EducationalStagesModel> {
        return this.repo.update(educationalStage)
    }

    async delete(id: EducationalStagesModel['id']): Promise<EducationalStagesModel> {
        return this.repo.delete(id)
    }

    async find(id: EducationalStagesModel['id']): Promise<EducationalStagesModel | undefined> {
        return this.repo.find(id)
    }

    async findMany(): Promise<EducationalStagesModel[]> {
        return this.repo.findMany()
    }

}