import type db from "@/db";
import { InstitutionRepo } from "@/db/repo/institutions.repo";
import type { InstitutionModel, InstitutionInput, InstitutionUpdate } from "@/db/schema/institution.schema";
import { Inject, Service } from "typedi";

@Service()
export class InstitutionService{
  @Inject()
  private readonly repo: InstitutionRepo

  async findMany():Promise<InstitutionModel[]>{
    
    return this.repo.findMany()
  }
  async findById(id: InstitutionModel['id']): Promise<InstitutionModel | null>{

    return this.repo.findById(id)
  }
  async findByName(name: InstitutionModel['name']): Promise<InstitutionModel | null>{
    
    return this.repo.findByName(name)
  }
  async findByUf(uf: InstitutionModel['uf']): Promise<InstitutionModel | null>{
    
    return this.repo.findByUf(uf)
  }
  async findByCity(city: InstitutionModel['city']): Promise<InstitutionModel | null>{
    
    return this.repo.findByCity(city)
  }
  async findByCep(cep: InstitutionModel['cep']): Promise<InstitutionModel | null>{
    
    return this.repo.findByCep(cep)
  }
  async create(role: InstitutionInput, tx?: db): Promise<InstitutionModel>{

    return this.repo.create(role, tx)
  }
  async update(role: InstitutionUpdate): Promise<InstitutionModel>{

    return this.repo.update(role)
  }
  async delete(id: InstitutionModel['id']): Promise<InstitutionModel>{

    return this.repo.delete(id)
  }
}