import { LicenseRepo } from "@/db/repo/licenses.repo";
import type { LicenseInput, LicenseModel, LicenseUpdate } from "@/db/schema/license.schema";
import { Inject, Service } from "typedi";


@Service()
export class LicenseService{
    @Inject()
    private readonly repo: LicenseRepo

    async create(license: LicenseInput): Promise<LicenseModel> {
        return this.repo.create(license)
    }

    async update(license: LicenseUpdate): Promise<LicenseModel> {
        return this.repo.update(license)
    }

    async delete(id: LicenseModel['id']): Promise<LicenseModel> {
        return this.repo.delete(id)
    }

    async find(id: LicenseModel['id']): Promise<LicenseModel | undefined> {
        return this.repo.find(id)
    }

    async findMany(): Promise<LicenseModel[]> {
        return this.repo.findMany()
    }

}