import { resourceLikesRepo } from "@/db/repo/resource-likes.repo";
import type { ResourceModel } from "@/db/schema/resource.schema";
import type { UserModel } from "@/db/schema/user.schema";
import { Inject, Service } from "typedi";

@Service()
export class ResourceLikesService {
    @Inject()
    private readonly repo: resourceLikesRepo;

    async associateResourceWithLikes(resourceId: ResourceModel['id'], userIds: UserModel['id'][]): Promise<void> {
        await this.repo.associateResourceWithLikes(resourceId, userIds);
    }

    async getLikesByResource(resourceId: ResourceModel['id']): Promise<UserModel[]> {
        return this.repo.getLikesbyResource(resourceId);
    }

    async removeLikesFromResource(resourceId: ResourceModel['id'], userIds: UserModel['id'][]): Promise<void> {
        await this.repo.removeLikesFromResource(resourceId, userIds);
    }

    async isAssociationExists(resourceId: ResourceModel['id'], userId: UserModel['id']): Promise<boolean> {
        return this.repo.isAssociationExists(resourceId, userId);
    }

    async getResourcesByUser(userId: UserModel['id']): Promise<ResourceModel[]> {
        return this.repo.getResourcesByLike(userId);
    }
}