import { resourceSubjects } from "@/db/repo/resource-subjects.repo";
import type { ResourceModel } from "@/db/schema/resource.schema";
import type { SubjectModel } from "@/db/schema/subject.schema";
import { Inject, Service } from "typedi";


@Service()
export class ResourceSubjectsService {
    @Inject()
    private readonly repo: resourceSubjects;

    async associateResourceWithSubjects(resourceId: ResourceModel['id'], subjects: SubjectModel['id'][]): Promise<void> {
        await this.repo.associateResourceWithSubjects(resourceId, subjects);
    }

    async getSubjectsByResource(resourceId: ResourceModel['id']): Promise<SubjectModel[]> {
        return await this.repo.getSubjectsByResource(resourceId);
    }

    async removeSubjectFromResource(resourceId: ResourceModel['id'], subjectIds: SubjectModel['id'][]): Promise<void> {
        await this.repo.removeSubjectFromResource(resourceId, subjectIds);
    }

    async isAssociationExists(resourceId: ResourceModel['id'], subjectId: SubjectModel['id']): Promise<boolean> {
        return await this.repo.isAssociationExists(resourceId, subjectId);
    }

    async getResourcesBySubject(subjectId: SubjectModel['id']): Promise<ResourceModel[]> {
        return await this.repo.getResourcesBySubject(subjectId);
    }

    async updateResourceSubjects(resourceId: ResourceModel['id'], newSubjectIds: SubjectModel['id'][]): Promise<void> {
        await this.repo.updateResourceSubjects(resourceId, newSubjectIds);
    }

}