import  { subjectsRepo } from "@/db/repo/subjects.repo";
import type { SubjectInput, SubjectModel, SubjectUpdate } from "@/db/schema/subject.schema";
import { Inject, Service } from "typedi";



@Service()
export class SubjectsService {
    @Inject()
    private readonly repo: subjectsRepo

    async create(subject: SubjectInput): Promise<SubjectModel> {
        return this.repo.create(subject)
    }

    async update(subject: SubjectUpdate): Promise<SubjectModel> {
        return this.repo.update(subject)
    }

    async delete(id: SubjectModel['id']): Promise<SubjectModel> {
        return this.repo.delete(id)
    }

    async find(id: SubjectModel['id']): Promise<SubjectModel | undefined> {
        return this.repo.find(id)
    }

    async findMany(): Promise<SubjectModel[]> {
        return this.repo.findMany()
    }
}