import type db from "@/db";
import { UserStatsRepo } from "@/db/repo/user-stats.repo";
import type { UserStatsModel, UserStatsUpdate } from "@/db/schema/user-stats.schema";
import { Inject, Service } from "typedi";

@Service()
export class UserStatsService{
    @Inject()
    private readonly repo: UserStatsRepo

    async findById(
        userStats_id: UserStatsModel['id']
    ): Promise<UserStatsModel | null>{
        return await this.repo.findById(userStats_id)
    }

    async create(
        tx?: db
    ): Promise<UserStatsModel>{
        return this.repo.create(tx)
    }

    async update(
        userStats: UserStatsUpdate
    ): Promise<UserStatsModel>{
        return this.repo.update(userStats)
    }

    async delete(
        userStats: UserStatsModel['id']
    ): Promise<UserStatsModel>{
        return this.repo.delete(userStats)
    }
}